#!/bin/bash
#
# TyStudio Automated Linux Installation Script, written by AlphaWolf_HK
# Copyright (C) 2003  Justin Decker, hawkeye100@hotmail.com
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

echo ""
echo "TyStudio, the Ultimate Tivo Media Software!"
echo "Version 0.5.0"
echo ""
echo "Automated Linux Installation Script by the TyStudio Team"
echo ""
echo -n "Begin installation process now? [yes]: "

read QUERYINSTALL; if [ "$QUERYINSTALL" == "" ]; then QUERYINSTALL=yes; fi

if [[ $QUERYINSTALL == "yes" || $QUERYINSTALL == "y" ]] ; then

echo ""

    # Check packager dependencies

    touch /usr/local/bin/roottest > /dev/null 2>&1
    USERNOTROOT=$?
    touch /usr/local/roottest > /dev/null 2>&1
    USERNOTROOT2=$?

    if [[ $USERNOTROOT == 1 || $USERNOTROOT2 == 1 ]]; then
    	
        echo "You need to be logged in as root first. (type \"su root\")"
        echo "Aborting."
        echo ""
        exit

    fi

    rm /usr/local/bin/roottest
    rm /usr/local/roottest
    
    which gzip > /dev/null 2>&1
    GZIPNOTINSTALLED=$?

    if [ $GZIPNOTINSTALLED == 1 ]; then
    
        echo "This package requires gzip to function, install it first."
        echo "Aborting."
        echo ""
        exit
        
    fi
    
    # Everything is good to go, lets proceed.

    echo "Please type the path to install TyStudio into [/usr/local/bin]:"
    read INSTALLPATH; if [ "$INSTALLPATH" == "" ]; then INSTALLPATH=/usr/local/bin; fi
    
    mkdir $INSTALLPATH > /dev/null 2>&1 # In case this is a second install...
    gzip -d -c ./tystudio.tar.gz |  ( cd  $INSTALLPATH ;  tar xpf - )
    rm /usr/local/bin/tystudio > /dev/null 2>&1 # In case this is a second install...
    ln -s $INSTALLPATH/tyeditor /usr/local/bin/tystudio
    
    echo ""
    echo "Done! Type \"tystudio\" (no quotes) at any time to run it."
    echo ""
    exit

else

    echo "Aborting."
    echo ""
    exit

fi

# We shouldn't ever make it here...

echo "Warning: Unknown error during install, possible problem."
