#include "dvmmpeg2.h"

/* 
 * This include file contains macros, declarations, etc. required
 * for the mpeg-2 package that should really be extensions/modifications
 * of other packages. They have been broken out into this separate file
 * so to facilitate integration of the mpeg-2 package into the official
 * Cornell distributions. 
 */


/* ByteField
 *
 * Definition of ByteField command which creates a virtual ByteImage
 * from a parent ByteImage comprised of every other line of the image.
 * This declaration should be moved to byte.c in the basic package.
 * The declaration of this function is currently in mpeg2compat.h
 * in the include directory and should be moved to the dvmbasic.h.
 */

ByteImage*
ByteField(buf, top_flag)
     ByteImage *buf;
     int top_flag;
{
  ByteImage *newBuf;

  newBuf = NEW(ByteImage);
  newBuf->x = buf->x;
  newBuf->y = buf->y;
  newBuf->width = buf->width;
  newBuf->height = buf->height/2;
  newBuf->isVirtual = 1;
  newBuf->parentWidth = buf->parentWidth * 2;
  
  if (top_flag) {
    newBuf->firstByte = buf->firstByte;
  } else {
    newBuf->firstByte = buf->firstByte + buf->parentWidth;
  }

  return newBuf;
}
