/*-------------------------------------
 * 
 * Copyright (c) 2000 by The University of North Carolina
 *
 * See the file "packages/mpeg2/nc_license.txt" for information 
 * on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 *-------------------------------------
 */

#include "mpeg2Int.h"

/*-----------------------------------------
 * Mpeg2MBInfoArrayNew
 *
 * Allocate a new Mpeg2MBInfoArray structure given
 * width w and height h.
 *-----------------------------------------*/
 
Mpeg2MBInfoArray *
Mpeg2MBInfoArrayNew(int w, int h)
{
  Mpeg2MBInfoArray *mbi_array;

  if ((w <= 0) || (h <= 0)) {
    return NULL;
  }
  mbi_array = NEW(Mpeg2MBInfoArray);

  mbi_array->width = w;
  mbi_array->height = h;

  mbi_array->mbinfo = (Mpeg2MBInfo *) malloc(sizeof(Mpeg2MBInfo) * w * h);
  return mbi_array;
}

/*-----------------------------------------
 * Mpeg2MBInfoArrayFree
 *
 * Free a previously allocated Mpeg2MBInfoArray
 *
 *-----------------------------------------*/

void
Mpeg2MBInfoArrayFree(Mpeg2MBInfoArray *mbi_array)
{
  if (mbi_array->mbinfo != NULL) {
    free((char *) mbi_array->mbinfo);
    mbi_array->mbinfo = NULL;
  }
  FREE((char *) mbi_array);
}


