#define MPEG2_COEFF_ILLEGAL_ENTRY -64
#define MPEG2_ESCAPE -16
#define MPEG2_END_OF_BLOCK -32
#define MPEG2_NEXT_TABLE_8 -1
#define MPEG2_NEXT_TABLE_7 -2
#define MPEG2_NEXT_TABLE_6 -3
#define MPEG2_NEXT_TABLE_5 -4
#define MPEG2_NEXT_TABLE_4 -5
#define MPEG2_NEXT_TABLE_3 -6
#define MPEG2_NEXT_TABLE_2 -7
#define MPEG2_NEXT_TABLE_1 -8

#define NO_VAL 0

#define COEFF_NEED_MORE_BITS(r) r < 0
#define COEFF_TABLE_IDX(r) r+8

/*
 * Tables for DCT coeff decoding. 
 */

char dct_coeff_run_table_zero[512] = {
  MPEG2_NEXT_TABLE_8, MPEG2_NEXT_TABLE_7, MPEG2_NEXT_TABLE_6, 
  MPEG2_NEXT_TABLE_5, MPEG2_NEXT_TABLE_4, MPEG2_NEXT_TABLE_1, 
  MPEG2_NEXT_TABLE_2, MPEG2_NEXT_TABLE_3, 
  MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  2, 2, 2, 2, 
  9, 9, 9, 9, 0, 0, 0, 0, 8, 8, 
  8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 
  6, 6, 6, 6, 6, 6, 6, 6, 1, 1, 
  1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
  5, 5, 5, 5, 13, 13, 0, 0, 12, 12, 
  11, 11, 3, 3, 1, 1, 0, 0, 10, 10, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0};


char dct_coeff_level_table_zero[512] = {
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 2, 2, -2, -2, 
  1, 1, -1, -1, 4, 4, -4, -4, 1, 1, 
  -1, -1, 1, 1, 1, 1, -1, -1, -1, -1, 
  1, 1, 1, 1, -1, -1, -1, -1, 2, 2, 
  2, 2, -2, -2, -2, -2, 1, 1, 1, 1, 
  -1, -1, -1, -1, 1, -1, 6, -6, 1, -1, 
  1, -1, 2, -2, 3, -3, 5, -5, 1, -1, 
  3, 3, 3, 3, 3, 3, 3, 3, -3, -3, 
  -3, -3, -3, -3, -3, -3, 1, 1, 1, 1, 
  1, 1, 1, 1, -1, -1, -1, -1, -1, -1, 
  -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, -2, -2, -2, -2, -2, -2, 
  -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1};

char dct_coeff_len_table_zero[512] = {
  9, 9, 9, 9, 9, 9, 9, 9, 6, 6, 
  6, 6, 6, 6, 6, 6, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3};


char dct_coeff_large_code_len_table_zero_T1_thru_T4[4] = {
  2, 2, 2, 2};

/* First 9 = 0000 0010 1 */

char dct_coeff_large_code_run_table_zero_T1[4] = {
  0, 0, 2, 2};
char dct_coeff_large_code_level_table_zero_T1[4] = {
  7, -7, 3, -3};

/* First 9 = 0000 0011 0 */

char dct_coeff_large_code_run_table_zero_T2[4] = {
  1, 1, 15, 15};
char dct_coeff_large_code_level_table_zero_T2[4] = {
  4, -4, 1, -1};

/* First 9 = 0000 0011 1 */
char dct_coeff_large_code_run_table_zero_T3[4] = {
  14, 14, 4, 4};
char dct_coeff_large_code_level_table_zero_T3[4] = {
  1, -1, 2, -2};

/* First 9 = 0000 0010 0 */
char dct_coeff_large_code_run_table_zero_T4[4] = {
  16, 16, 5, 5};
char dct_coeff_large_code_level_table_zero_T4[4] = {
  1, -1, 2, -2};

char dct_coeff_large_code_len_table_zero_T5_thru_T6[16] = {
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4};

/* First 9 = 0000 0001 1 */
char dct_coeff_large_code_run_table_zero_T5[16] = {
  0, 0, 19, 19, 18, 18, 1, 1, 3, 3, 0, 0, 6, 6, 17, 17};
char dct_coeff_large_code_level_table_zero_T5[16] = {
  9, -9, 1, -1, 1, -1, 5, -5, 3, -3, 8, -8, 2, -2, 1, -1};

/* First 9 = 0000 0001 0 */
char dct_coeff_large_code_run_table_zero_T6[16] = {
  0, 0, 8, 8, 4, 4, 0, 0, 2, 2, 7, 7, 21, 21, 20, 20};

char dct_coeff_large_code_level_table_zero_T6[16] = {
  11, -11, 2, -2, 3, -3, 10, -10, 4, -4, 2, -2, 1, -1, 1, -1};

/* First 9 = 0000 0000 1 */

char dct_coeff_large_code_len_table_zero_T7[32] = {
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5};

char dct_coeff_large_code_run_table_zero_T7[32] = {
  10, 10,  9,  9,  5,  5,  3,  3, 
  2,   2,  1,  1,  1,  1,  0,  0, 
  0,   0,  0,  0,  0,  0, 26, 26, 
  25, 25, 24, 24, 23, 23, 22, 22};

char dct_coeff_large_code_level_table_zero_T7[32] = {
   2,  -2,  2,  -2,  3,  -3,  4,  -4, 
   5,  -5,  7,  -7,  6,  -6, 15, -15, 
  14, -14, 13, -13, 12, -12,  1,  -1, 
   1,  -1,  1,  -1,  1,  -1,  1,  -1};

char dct_coeff_large_code_len_table_zero_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6};
  
char dct_coeff_large_code_run_table_zero_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  1, 1, 1, 1, 1, 1, 1, 1, 
  6, 6, 16, 16, 15, 15, 14, 14, 13, 13, 
  12, 12, 11, 11, 31, 31, 30, 30, 29, 29, 
  28, 28, 27, 27, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0};
  
char dct_coeff_large_code_level_table_zero_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  18, -18, 17, -17, 16, -16, 15, -15, 
  3, -3, 2, -2, 2, -2, 2, -2, 2, -2, 
  2, -2, 2, -2, 1, -1, 1, -1, 1, -1, 
  1, -1, 1, -1, 40, 40, -40, -40, 39, 39, 
  -39, -39, 38, 38, -38, -38, 37, 37, -37, -37, 
  36, 36, -36, -36, 35, 35, -35, -35, 34, 34, 
  -34, -34, 33, 33, -33, -33, 32, 32, -32, -32, 
  14, 14, -14, -14, 13, 13, -13, -13, 12, 12, 
  -12, -12, 11, 11, -11, -11, 10, 10, -10, -10, 
  9, 9, -9, -9, 8, 8, -8, -8, 31, 31, 
  31, 31, -31, -31, -31, -31, 30, 30, 30, 30, 
  -30, -30, -30, -30, 29, 29, 29, 29, -29, -29, 
  -29, -29, 28, 28, 28, 28, -28, -28, -28, -28, 
  27, 27, 27, 27, -27, -27, -27, -27, 26, 26, 
  26, 26, -26, -26, -26, -26, 25, 25, 25, 25, 
  -25, -25, -25, -25, 24, 24, 24, 24, -24, -24, 
  -24, -24, 23, 23, 23, 23, -23, -23, -23, -23, 
  22, 22, 22, 22, -22, -22, -22, -22, 21, 21, 
  21, 21, -21, -21, -21, -21, 20, 20, 20, 20, 
  -20, -20, -20, -20, 19, 19, 19, 19, -19, -19, 
  -19, -19, 18, 18, 18, 18, -18, -18, -18, -18, 
  17, 17, 17, 17, -17, -17, -17, -17, 16, 16, 
  16, 16, -16, -16, -16, -16};


char dct_coeff_large_code_num_bits_table_zero[8] = {
  2, 2, 2, 2, 4, 4, 5, 8
};

char *dct_coeff_large_code_run_table_zero[8] = {
  dct_coeff_large_code_run_table_zero_T1,
  dct_coeff_large_code_run_table_zero_T2,
  dct_coeff_large_code_run_table_zero_T3,
  dct_coeff_large_code_run_table_zero_T4,
  dct_coeff_large_code_run_table_zero_T5,
  dct_coeff_large_code_run_table_zero_T6,
  dct_coeff_large_code_run_table_zero_T7,
  dct_coeff_large_code_run_table_zero_T8};

char *dct_coeff_large_code_level_table_zero[8] = {
  dct_coeff_large_code_level_table_zero_T1,
  dct_coeff_large_code_level_table_zero_T2,
  dct_coeff_large_code_level_table_zero_T3,
  dct_coeff_large_code_level_table_zero_T4,
  dct_coeff_large_code_level_table_zero_T5,
  dct_coeff_large_code_level_table_zero_T6,
  dct_coeff_large_code_level_table_zero_T7,
  dct_coeff_large_code_level_table_zero_T8};

char *dct_coeff_large_code_len_table_zero[8] = {
  dct_coeff_large_code_len_table_zero_T1_thru_T4,
  dct_coeff_large_code_len_table_zero_T1_thru_T4,
  dct_coeff_large_code_len_table_zero_T1_thru_T4,
  dct_coeff_large_code_len_table_zero_T1_thru_T4,
  dct_coeff_large_code_len_table_zero_T5_thru_T6,
  dct_coeff_large_code_len_table_zero_T5_thru_T6,
  dct_coeff_large_code_len_table_zero_T7,
  dct_coeff_large_code_len_table_zero_T8,
};


char dct_coeff_run_table_one[512] = {
  MPEG2_NEXT_TABLE_8, MPEG2_NEXT_TABLE_7, MPEG2_NEXT_TABLE_6, 
  MPEG2_NEXT_TABLE_5, MPEG2_NEXT_TABLE_1, MPEG2_NEXT_TABLE_2, 
  MPEG2_NEXT_TABLE_4, MPEG2_NEXT_TABLE_3, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  MPEG2_ESCAPE, 7, 7, 7, 7, 
  8, 8, 8, 8, 6, 6, 6, 6, 2, 2, 
  2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 
  4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 
  5, 5, 5, 5, 1, 1, 11, 11, 0, 0, 
  0, 0, 13, 13, 12, 12, 3, 3, 1, 1, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 
  MPEG2_END_OF_BLOCK, MPEG2_END_OF_BLOCK, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  9, 9, 9, 9, 1, 1, 1, 1, 10, 10, 
  10, 10, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 2, 2, 4, 4, 0, 0, 
  0, 0};

char dct_coeff_level_table_one[512] = {
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 1, 1, -1, -1, 
  1, 1, -1, -1, 1, 1, -1, -1, 2, 2, 
  -2, -2, 7, 7, 7, 7, -7, -7, -7, -7, 
  6, 6, 6, 6, -6, -6, -6, -6, 1, 1, 
  1, 1, -1, -1, -1, -1, 1, 1, 1, 1, 
  -1, -1, -1, -1, 5, -5, 1, -1, 11, -11, 
  10, -10, 1, -1, 1, -1, 2, -2, 4, -4, 
  1, 1, 1, 1, 1, 1, 1, 1, -1, -1, 
  -1, -1, -1, -1, -1, -1, 2, 2, 2, 2, 
  2, 2, 2, 2, -2, -2, -2, -2, -2, -2, 
  -2, -2, 1, 1, 1, 1, 1, 1, 1, 1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  -3, -3, -3, -3, -3, -3, -3, -3, -3, -3, 
  -3, -3, -3, -3, -3, -3, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, -2, -2, -2, -2, 
  -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, 
  -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, 
  -2, -2, -2, -2, -2, -2, -2, -2, 4, 4, 
  4, 4, 4, 4, 4, 4, -4, -4, -4, -4, 
  -4, -4, -4, -4, 5, 5, 5, 5, 5, 5, 
  5, 5, -5, -5, -5, -5, -5, -5, -5, -5, 
  1, 1, -1, -1, 3, 3, -3, -3, 1, 1, 
  -1, -1, 8, 8, -8, -8, 9, 9, -9, -9, 
  12, -12, 13, -13, 3, -3, 2, -2, 14, -14, 
  15, -15};  

char dct_coeff_len_table_one[512] = {
  9, 9, 9, 9, 9, 9, 9, 9, 6, 6, 
  6, 6, 6, 6, 6, 6, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
  9, 9};

char dct_coeff_large_code_len_table_one_T1_thru_T3[2] = {1, 1};

/* First 9 = 0000 0010 0 */
char dct_coeff_large_code_run_table_one_T1[2] = {5, 5};
char dct_coeff_large_code_level_table_one_T1[2] = {2, -2};

/* First 9 - 0000 0010 1 */ 
char dct_coeff_large_code_run_table_one_T2[2] = {14, 14};
char dct_coeff_large_code_level_table_one_T2[2] = {1, -1};

/* First 9 - 0000 0011 1 */ 
char dct_coeff_large_code_run_table_one_T3[2] = {15, 15};
char dct_coeff_large_code_level_table_one_T3[2] = {1, -1};

/* First 9 - 0000 0011 0 */
char dct_coeff_large_code_len_table_one_T4[4] = {2, 2, 2, 2};
char dct_coeff_large_code_run_table_one_T4[4] = {2, 2, 16, 16};
char dct_coeff_large_code_level_table_one_T4[4] = {4, -4, 1, -1};

/* First 9 - 0000 0001 1 */
char dct_coeff_large_code_len_table_one_T5_thru_T6[16] = {
  4, 4, 4, 4, 4, 4, 4, 4,
  4, 4, 4, 4, 4, 4, 4, 4};
char dct_coeff_large_code_run_table_one_T5[16] = {
  NO_VAL, NO_VAL, 19, 19, 18, 18, NO_VAL, NO_VAL, 
  3, 3, NO_VAL, NO_VAL, 6, 6, 17, 17};
char dct_coeff_large_code_level_table_one_T5[16] = {
  NO_VAL, NO_VAL, 1, -1, 1, -1, NO_VAL, NO_VAL,
  3, -3, NO_VAL, NO_VAL< 2, -2, 1, -1};

/* First 9 = 0000 0001 0 */
char dct_coeff_large_code_run_table_one_T6[16] = {
  NO_VAL, NO_VAL, 8, 8, 4, 4, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, 7, 7, 21, 21, 20, 20};
char dct_coeff_large_code_level_table_one_T6[16] = {
  NO_VAL, NO_VAL, 2, -2, 3, -3, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, 2, -2, 1, -1, 1, -1};

/* First 9 = 0000 0000 1 */
char dct_coeff_large_code_len_table_one_T7[32] = {
  5, 5, 5, 5, 5, 5, 5, 5,
  5, 5, 5, 5, 5, 5, 5, 5,
  5, 5, 5, 5, 5, 5, 5, 5,
  5, 5, 5, 5, 5, 5, 5, 5};
char dct_coeff_large_code_run_table_one_T7[32] = {
      10,     10,      9,      9,      5,      5,      3,      3, 
       2,      2,      1,      1,      1,      1, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL,     26,     26,
      25,     25,     24,     24,     23,     23,     22,     22};
char dct_coeff_large_code_level_table_one_T7[32] = {
       2,     -2,      2,     -2,      3,     -3,      4,     -4, 
       5,     -5,      7,     -7,      6,     -6, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL,      1,     -1,
       1,     -1,      1,     -1,      1,     -1,      1,     -1};

/* First 9 = 0000 0000 0 */
char dct_coeff_large_code_run_table_one_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  1, 1, 1, 1, 1, 1, 1, 1, 
  6, 6, 16, 16, 15, 15, 14, 14, 13, 13, 
  12, 12, 11, 11, 31, 31, 30, 30, 29, 29, 
  28, 28, 27, 27, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0};
char dct_coeff_large_code_level_table_one_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  18, -18, 17, -17, 16, -16, 15, -15, 
  3, -3, 2, -2, 2, -2, 2, -2, 2, -2, 
  2, -2, 2, -2, 1, -1, 1, -1, 1, -1, 
  1, -1, 1, -1, 40, 40, -40, -40, 39, 39, 
  -39, -39, 38, 38, -38, -38, 37, 37, -37, -37, 
  36, 36, -36, -36, 35, 35, -35, -35, 34, 34, 
  -34, -34, 33, 33, -33, -33, 32, 32, -32, -32, 
  14, 14, -14, -14, 13, 13, -13, -13, 12, 12, 
  -12, -12, 11, 11, -11, -11, 10, 10, -10, -10, 
  9, 9, -9, -9, 8, 8, -8, -8, 31, 31, 
  31, 31, -31, -31, -31, -31, 30, 30, 30, 30, 
  -30, -30, -30, -30, 29, 29, 29, 29, -29, -29, 
  -29, -29, 28, 28, 28, 28, -28, -28, -28, -28, 
  27, 27, 27, 27, -27, -27, -27, -27, 26, 26, 
  26, 26, -26, -26, -26, -26, 25, 25, 25, 25, 
  -25, -25, -25, -25, 24, 24, 24, 24, -24, -24, 
  -24, -24, 23, 23, 23, 23, -23, -23, -23, -23, 
  22, 22, 22, 22, -22, -22, -22, -22, 21, 21, 
  21, 21, -21, -21, -21, -21, 20, 20, 20, 20, 
  -20, -20, -20, -20, 19, 19, 19, 19, -19, -19, 
  -19, -19, 18, 18, 18, 18, -18, -18, -18, -18, 
  17, 17, 17, 17, -17, -17, -17, -17, 16, 16, 
  16, 16, -16, -16, -16, -16};

char dct_coeff_large_code_len_table_one_T8[256] = {
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  MPEG2_COEFF_ILLEGAL_ENTRY, MPEG2_COEFF_ILLEGAL_ENTRY, 
  8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6};

char dct_coeff_large_code_num_bits_table_one[8] = {
  1, 1, 1, 2, 4, 4, 5, 8};

char *dct_coeff_large_code_run_table_one[8] = {
  dct_coeff_large_code_run_table_one_T1,
  dct_coeff_large_code_run_table_one_T2,
  dct_coeff_large_code_run_table_one_T3,
  dct_coeff_large_code_run_table_one_T4,
  dct_coeff_large_code_run_table_one_T5,
  dct_coeff_large_code_run_table_one_T6,
  dct_coeff_large_code_run_table_one_T7,
  dct_coeff_large_code_run_table_one_T8};

char *dct_coeff_large_code_level_table_one[8] = {
  dct_coeff_large_code_level_table_one_T1,
  dct_coeff_large_code_level_table_one_T2,
  dct_coeff_large_code_level_table_one_T3,
  dct_coeff_large_code_level_table_one_T4,
  dct_coeff_large_code_level_table_one_T5,
  dct_coeff_large_code_level_table_one_T6,
  dct_coeff_large_code_level_table_one_T7,
  dct_coeff_large_code_level_table_one_T8};

char *dct_coeff_large_code_len_table_one[8] = {
  dct_coeff_large_code_len_table_one_T1_thru_T3,
  dct_coeff_large_code_len_table_one_T1_thru_T3,
  dct_coeff_large_code_len_table_one_T1_thru_T3,
  dct_coeff_large_code_len_table_one_T4,
  dct_coeff_large_code_len_table_one_T5_thru_T6,
  dct_coeff_large_code_len_table_one_T5_thru_T6,
  dct_coeff_large_code_len_table_one_T7,
  dct_coeff_large_code_len_table_one_T8};


char dct_first_coeff_run_table_zero[512] = {
  MPEG2_NEXT_TABLE_8, MPEG2_NEXT_TABLE_7, MPEG2_NEXT_TABLE_6, 
  MPEG2_NEXT_TABLE_5, MPEG2_NEXT_TABLE_4, MPEG2_NEXT_TABLE_1, 
  MPEG2_NEXT_TABLE_2, MPEG2_NEXT_TABLE_3, 
  MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  MPEG2_ESCAPE, MPEG2_ESCAPE, MPEG2_ESCAPE, 
  2, 2, 2, 2, 
  9, 9, 9, 9, 0, 0, 0, 0, 8, 8, 
  8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 
  6, 6, 6, 6, 6, 6, 6, 6, 1, 1, 
  1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 
  5, 5, 5, 5, 13, 13, 0, 0, 12, 12, 
  11, 11, 3, 3, 1, 1, 0, 0, 10, 10, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 
  3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
  0, 0};

static char dct_first_coeff_level_table_zero[512] = {
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, NO_VAL, 
  2, 2, -2, -2, 
  1, 1, -1, -1, 4, 4, -4, -4, 1, 1, 
  -1, -1, 1, 1, 1, 1, -1, -1, -1, -1, 
  1, 1, 1, 1, -1, -1, -1, -1, 2, 2, 
  2, 2, -2, -2, -2, -2, 1, 1, 1, 1, 
  -1, -1, -1, -1, 1, -1, 6, -6, 1, -1, 
  1, -1, 2, -2, 3, -3, 5, -5, 1, -1, 
  3, 3, 3, 3, 3, 3, 3, 3, -3, -3, 
  -3, -3, -3, -3, -3, -3, 1, 1, 1, 1, 
  1, 1, 1, 1, -1, -1, -1, -1, -1, -1, 
  -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 
  -1, -1, -1, -1, -1, -1, -1, -1, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, -2, -2, -2, -2, -2, -2, 
  -2, -2, -2, -2, -2, -2, -2, -2, -2, -2, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
  1, 1, 1, 1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 
  -1, -1};

static char dct_first_coeff_len_table_zero[512] = {
  9, 9, 9, 9, 9, 9, 9, 9, 6, 6, 
  6, 6, 6, 6, 6, 6, 8, 8, 8, 8, 
  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
  8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
  7, 7, 7, 7, 9, 9, 9, 9, 9, 9, 
  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
  6, 6, 6, 6, 6, 6, 6, 6, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
  5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 
  4, 4, 4, 4, 4, 4, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
  2, 2};

#undef NO_VAL

