#include "logfileimpl.h"

#include <qmultilineedit.h>
#include <tycommon.h>
#include <stdio.h>

/* 
 *  Constructs a logfile which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
logfile::logfile( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : logfileBase( parent, name, modal, fl )
{
	refresh();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
logfile::~logfile()
{
    // no need to delete child widgets, Qt does it all for us
}

void logfile::refresh()
{
	editlog->clear();

	FILE * fh = fsopen( "editorlog.txt", READ_MODE, SHARE_DENY_NONE );
	if( fh ) {
		char buffer[1025];
		int nBytes;
		while( (nBytes = fread( buffer, 1, 1024, fh )) ) {
			buffer[nBytes] = 0;
			editlog->append( buffer );
		}
	}
}
