#ifndef NOWSHOWING_H
#define NOWSHOWING_H
#include "nowshowing.h"

#include "tydemuxclass.h"

class NowShowing : public NowShowingBase
{ 
    Q_OBJECT

public:
    NowShowing( const char *tivoHost, CDemuxInterface *pDemux, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~NowShowing();

	const char *GetStreamName() { return m_StreamName; };
	int GetFsid() { return m_fsid; };
	bool CopyToPC() { return m_CopyToPC; };

public slots:
	void ListCurrentChanged ( QListViewItem *newCurrent );
	void ListDoubleClick ( QListViewItem * item);
	void onRefresh();
	void onCopyToPC();

private:
	void UpdateScreenList();
	QString m_StreamName;

	CDemuxInterface *m_pDemux;
	CTivoFile *m_pList;
	int m_fsid;
	bool m_CopyToPC;
};

#endif // NOWSHOWING_H
