/*
 * Copyright (C) 2002, 2003  John Barrett (MrBassMan) <johnbarretthcc@hotmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: tymainwindow.h,v 1.12 2003/03/30 01:41:14 mrbassman Exp $ */

#include <qmainwindow.h>
#include <qaction.h>

#include "tydemuxclass.h"

#include "tyeditorwindow.h"
#include "logfileimpl.h"
#include "optionsimpl.h"

class tymainWindow : public QMainWindow
{
	Q_OBJECT
public:
	tymainWindow( QWidget* parent = 0, const char* name = 0 );
	~tymainWindow();

	CDemuxInterface *GetDemuxer() { return m_pDemux; };
	void startNewDemuxSession();
	void doIndex();
	bool doCopyFile( int fsid, const char *dest );
	options *GetOptions() { return m_pOptions; };

public slots:
    void fileNew();
    void fileOpen();
    void fileOpenTy();
    void fileOpenTivo();
    void fileSave();
    void fileSaveAs();
	void fileSaveImage(int);
	void FrameCounter();
	void TimeCounter();
    void toolsOptions();
    void helpAbout();
	void helpKeys();
	void Process();
	void LogFile();

private:
	void	SetStreamName( const char *name );
	QString m_CutFile;
	QString m_tyFile;
	QString m_StreamName;
	QPopupMenu *fileSaveImageMenu;
	tyeditorWindow *m_editWindow;
	FILE *m_Logfile;
    QAction *viewLogFile;
    QAction *viewFrameCounter;
    QAction *viewTimeCounter;
	logfile *m_pLog;
	QPixmap m_Icon;
	CDemuxInterface *m_pDemux;
	options *m_pOptions;
};

