/*
 * Copyright (C) 2002  John Barrett <johnbarretthcc@hotmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* "$Id: tymplex.h,v 1.5 2003/03/14 19:08:10 mrbassman Exp $" */
/* TyMplex - a wrapper program for a threaded version of the mjpeg mplex code */

#include <vector>

/* Startup parameters passed to the mplex thread in user_data */
typedef struct {
	int	argc;						/* Additional mplex parameters from the command line */
	char **argv;					/* As above */
	int format;						/* Mplex -f parameter (+1) over-ride 0 for default */
	bool running;					/* Set to true once the mplex thread starts */
	mutex_handle_t thread_lock;		/* Used to lock the main program until mplex has finished */
	int wait_for_audio_offset;		/* If set to 1, mplex will block waiting for it to change to zero */
	int audio_offset;				/* Audio offset to be used */
	pipe_handle_t	audio_pipe;		/* Pipe for input audio */
	pipe_handle_t	video_pipe;		/* Pipe for input video */
	pipe_handle_t	output_pipe;	/* Pipe for resulting mpeg */

	log_hook_function	loghookfn;
	loglevel_t			loglevel;
	FILE	*			logfile;

} mplex_start_params_t;

#ifdef __cplusplus
extern "C" {
#endif

extern int mplex_thread( void *user_data );

#ifdef __cplusplus
}
#endif
