/*
 * Copyright (C) 2002  John Barrett <johnbarretthcc@hotmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* "$Id: tytranscode.h,v 1.9 2003/03/16 02:20:27 mrbassman Exp $" */

#ifdef __cplusplus
extern "C" {
#endif

#include "../libs/threadlib.h"
#undef LOG_MODULE
#define LOG_MODULE "transcode"
#include "tylogging.h"

#define DEFAULT_DB_ADJUST 255

/* Startup parameters passed to the transcode thread in user_data */
typedef struct {
	int	argc;						/* Additional mplex parameters from the command line */
	char **argv;					/* As above */
	int running;					/* Set to true once the transcode thread starts */
	mutex_handle_t thread_lock;		/* Used to lock the main program until mplex has finished */

	int format;						/* 1 for AC3, 0 for MPEG */
	int rate;						/* New sample rate */
	int bitrate;					/* New bit rate */
  int dbadjust;         /* db adjust level */

	pipe_handle_t input_pipe;		/* Input pipe to use */
	pipe_handle_t output_pipe;		/* Output pipe to use */

	log_hook_function	loghookfn;
	loglevel_t			loglevel;
	FILE	*			logfile;

} transcode_start_params_t;

extern int transcode_thread( void *user_data );

#ifdef __cplusplus
}
#endif
